#include "bptt.h"


 /* diplays network configuration */

void display (string tokens[]) 
    {
      fprintf (OUT,"\n   Units = %d\tCopies = %d", NET_UNITS, NET_COPIES);
      fprintf (OUT,"\tInputs = %d\tOutputs = %d\n", NET_INPUTS, NET_OUTPUTS);
      fprintf (OUT,"   Delay = %d\tDwell = %d", DELAY, DWELL);
      fprintf (OUT,"\tBias = %6.3lf", BIAS);
      fprintf (OUT,"\n\n   Fixed weights: ");
      /* print out any fixed weights */
      if (*FIX_LIST)
	fprintf (OUT,"%s\n", FIX_LIST);
      else
	fprintf (OUT,"none\n");
      if (!PSOURCE)
	fprintf (OUT,"\n   Number of Patterns: %d\n", FILE_NO_LINES);
      else
	fprintf (OUT,"\n   Function = <Pattern_Generator_%d>\n", PSOURCE);
    }





 /* diplays the file name of the most recently loaded weights and patters */

void display_source (string tokens[])
{
  fprintf (OUT,"\n   Weight Source: \"%s\"",
	  (*WEIGHT_FILE) ? WEIGHT_FILE : "<unspecified>");
  if (!PSOURCE)
    {
      fprintf (OUT,"\n   Input Pattern Source: %s",
	      (*INPUT_PATTERN_FILE) ? INPUT_PATTERN_FILE : "<unspecified>");
      fprintf (OUT,"\n   Teacher Pattern Source: %s",
	      (*TEACHER_PATTERN_FILE) ? TEACHER_PATTERN_FILE : "<unspecified>");
    }
  else
    fprintf (OUT,"\n   Function Source: Generator #%d",
	    PSOURCE);
  fprintf (OUT,"\n");
}




 /* displays parameter list */

void display_parameters (string tokens[])
{
  int i;

  fprintf (OUT,"\n   ");
  for (i=0; param_list[i].name; i++)
    {
      fprintf (OUT,"%s", get_parameter_string (i));
      if (((i+1) % 3) == 0)
	fprintf (OUT,"\n   ");
    }
  fprintf (OUT, "\n");
}


 /* dispalys text picuture of the network */

void display_network (string tokens[])
{
  int i, j;

  if (INIT_NET_FLAG) {err (3, ""); return;};

  fprintf (OUT, "\n");
  for (i=0; i < NET_COPIES; i++)
    {
      fprintf (OUT,"   B ");
      for (j=1; j < (NET_INPUTS); j++)
	fprintf (OUT, "I ");
      fprintf (OUT, "---> ");
      for (j=0; j < NET_OUTPUTS; j++)
	fprintf (OUT, "O ");
      for (j=0; j < (NET_UNITS-NET_OUTPUTS); j++)
	fprintf (OUT, "R ");
      fprintf (OUT, "\n");
    }
}
      


 /* displays the patterns */

void display_patterns (string tokens[])
{
  int i,j, start, end;
  double inputs [MAX_INPUTS],
         teachers [MAX_UNITS];
  int tmasks [MAX_UNITS];
  char *p;

  if (! PSOURCE) /* if using files */
    {
      if (INIT_PATTERN_FLAG)
	{
	  err (15, "");
	  return;
	}


      /* compute the range specifed */

      start = end = atoi (tokens[1]);
      if ((start<0) || (start >= FILE_NO_LINES))
	{
	  err (25, "");
	  return;
	}
      if (!isdigit (tokens[1][0])) end = FILE_NO_LINES-1;
      if (p = strpbrk (tokens[1], "-"))
	{
	  end = atoi (p+1);
	  if ((end<0) || (end>=FILE_NO_LINES))
	    {
	      err (25, "");
	      return;
	    }
	  if (end==0) end = FILE_NO_LINES-1;
	}


      fprintf (OUT,"\n   FILE source:  (inputs)  |  (teachers)  |  (tmasks)\n\n");
      for (i=start; i<=end; i++)
	{
	  for (j=1; j<NET_INPUTS; j++)
	    fprintf (OUT,"  %6.3lf  ", INPUTS[i][j]);
	  fprintf (OUT," | ");
	  for (j=0; j<NET_OUTPUTS; j++)
	    fprintf (OUT,"%6.3lf  ", TEACHERS[i][j]);
	  fprintf (OUT," |   ");
	  for (j=0; j<NET_OUTPUTS; j++)
	    fprintf (OUT,"%d  ", TMASKS[i][j]);
	  fprintf (OUT,"\n");
	}
    }

  else /* otherwise using functions */

    if (atoi (tokens[1]) > 0) /* make sure user specified a iteration number */
      {
	fprintf (OUT,"\n   FUNCTION source:  (inputs) |  (teachers) |  (tmasks)\n\n");
	(*generators [PSOURCE]) (inputs, teachers, tmasks, TRUE);
	for (i=0; i < atoi (tokens[1]); i++)
	  {
	    fprintf (OUT,"  ");
	    (*generators [PSOURCE]) (inputs, teachers, tmasks, NULL);
	    for (j=1; j<NET_INPUTS; j++)
	      fprintf (OUT,"%6.3lf  ", inputs[j]);
	    fprintf (OUT," | ");
	    for (j=0; j<NET_OUTPUTS; j++)
	      fprintf (OUT,"%6.3lf  ", teachers[j]);
	    fprintf (OUT," |   ");
	    for (j=0; j<NET_OUTPUTS; j++)
	      fprintf (OUT,"%d  ", tmasks[j]);
	    fprintf (OUT,"\n");
	  }
      }
    else
      err (26, "");
}
