#include "bptt.h"

				/* acutally does the array init stuff */
void init_net_call ()
{
  int s, i, j;

  for (i=0; i<MAX_COPIES; i++)	/* zero entire net */
    {
      for (j=0; j<MAX_UNITS; j++)
	{
	  for (s=0; s<MAX_UNITS; s++)
	    RW[i][j][s] = 0.0;
	  for (s=0; s<MAX_INPUTS; s++)
	    InW[i][j][s] = 0.0;
	  RA[i][j] = 0.0;
	}
      for (j=0; j<MAX_INPUTS; j++)
	InA[i][j] = 0.0;
    }

  cp = 0;

  for (i=0; i<NET_COPIES; i++)		/* initialize weights */
    for (j=0; j<NET_UNITS; j++)
      {
	for (s=0; s<NET_UNITS; s++)
	  RW[i][j][s] = rnd () * (WEIGHT_RANGE * 2) - WEIGHT_RANGE;
	for (s=0; s<NET_INPUTS; s++)
	  InW[i][j][s] = rnd () * (WEIGHT_RANGE * 2) - WEIGHT_RANGE;
      }
  
  for (i=0; i<NET_UNITS; i++)		/* initialize weight mask */
    {
      for (j=0; j<NET_UNITS; j++)
	{
	  RecWMask [i][j] = 0;
	  RecWFix [i][j] = 0;
	}
      for (j=0; j<NET_INPUTS; j++)
	{
	  InWMask [i][j] = 0;
	  InWFix [i][j] =0;
	}
    }

  *FIX_LIST = NULL;
  *WEIGHT_FILE = NULL;

}

void initialize_weights (string tokens[])
{
				/* make sure their is a network */

  if ((INIT_NET_FLAG) || (NET_OUTPUTS == 0))
    {
      err (3, "");
      return;
    }

				/* set random seed */
  if (str_eq (tokens[1], "-s"))
    srand48 (atoi (tokens[2]));
  else
    srand48 (time(NULL));

				/* initialize the arrays */
  init_net_call ();
  INIT_WEIGHT_FLAG = 0;
  fprintf (OUT, "\n   Network Initialized\n");
}

				/* used to fix weights */
				/* kind of a hacky function */
				/* could stand some improvement */
void fix_weights (string tokens[])
{
  int i, j, from_num, to_num;
  char *from, *to, *value;
  double f_val [MAX_TOKENS];
  char f_string [MAX_TOKENS][MAX_TEMPLATE_LINE_LENGTH+3],
       t_string [MAX_TOKENS][MAX_TEMPLATE_LINE_LENGTH+3],
       temp_tokens [MAX_TOKENS][MAX_STRING];
  
  for (i=1; tokens[i][0]; i++)
    {
      *f_string [i] = NULL;
      *t_string [i] = NULL;
      strncpy (temp_tokens [i], tokens[i], MAX_STRING);
      from = strtok (tokens[i], "()");
      to = strtok (NULL, "()");
      value = strtok (NULL, "()");
      if (! (from && to && value))
	err (23, "");

      if (str_eq (from, "rec"))
	strcpy (from, "r0-U");
      else
        if (str_eq (from, "inp"))
	  strcpy (from, "i1-I");
	else
	  if (str_eq (from, "out"))
	    strcpy (from, "r0-O");
      if (str_eq (to, "rec"))
	strcpy (to, "r0-U");
      else
        if (str_eq (to, "inp"))
	  strcpy (to, "i1-I");
	else
	  if (str_eq (to, "out"))
	    strcpy (to, "r0-O");
      
      if (! (strchr ("r", from[0]) &&
	     strchr ("ri", to[0])))
	err (23, "");
      
      add_unit_list (f_string [i], from, MAX_TEMPLATE_LINE_LENGTH, 23, "");
      add_unit_list (t_string [i], to, MAX_TEMPLATE_LINE_LENGTH, 23, "");
      f_val [i] = atof (value);
    }

  for (i--; i > 0; i--)
    {
      if (!strstr (FIX_LIST, temp_tokens[i]))
	{
	  add_string (FIX_LIST, temp_tokens [i], MAX_STRING);
	  add_string (FIX_LIST, " ", MAX_STRING);
	}
      for (from = f_string[i]; from && from[0] == TEMPLATE_COMMAND_CHAR; from = strpbrk (from, "*"))
	{
	  from++;
	  from_num = atoi (from+1);
	  if ((from_num < 0) || (from_num >= NET_UNITS))
	    break;
	  for (to = t_string[i]; to && to[0] == TEMPLATE_COMMAND_CHAR; to = strpbrk (to, "*"))
	    {
	      to++;
	      to_num = atoi (to+1);
	      if (*to == 'i')
		if ((to_num<0) || (to_num>=NET_INPUTS))
		  break;
		else
		  {
		    InWMask [from_num][to_num] = 1;
		    InWFix [from_num][to_num] = f_val[i];
		  }
	      else
		if ((to_num<0) || (to_num>=NET_UNITS))
		  break;
		else
		  {
		    RecWMask [from_num][to_num] = 1;
		    RecWFix [from_num][to_num] = f_val[i];
		  }
	      for (j=0; j<NET_COPIES; j++)
		if (*to == 'i')
		  InW [j][from_num][to_num] = f_val[i];
		else
		  RW [j][from_num][to_num] = f_val[i];}
	}
    }
}



double rnd ()
{
  return (double) (lrand48 () / 2147483647.0);
}
