#include "bptt.h"

/* checks the character under the file pointer without moving it */

char peek_file (FILE *fp)
{
  char t;

  t = fgetc (fp);
  if (!feof (fp))
    {
      fseek (fp, -1, SEEK_CUR);
      return t;
    }
  return NULL;
}




/* fopen file and keep an array going of all open files */

FILE *my_fopen (char *name, char *what)
{
  FILE *fp;
  string temp;
  
  if (*name == '~')
    {
      strncpy (temp, HOME_DIR, MAX_STRING);
      strncat (temp, name+1, MAX_STRING);
      strncpy (name, temp, MAX_STRING);
    }
      
  fp = fopen (name, what);

  if (!fp)
    if (str_eq (what, "w"))
      err (20, name);
    else
      return NULL;

  if (FILE_NUM>=MAX_OPEN_FILES)	/* a little hack, should never happen */
    {
      fprintf (stderr, "\n\nToo many files open.. Aborting\n\n");
      exit (1);
    }

  FILE_LIST [FILE_NUM] = fp;
  FILE_NUM++;
  return fp;
}


/* fclose file and erase file from array of open files */

int my_fclose (FILE *fp)
{
  int i,j;

  for (i=0; (i<FILE_NUM) && (fp != FILE_LIST [i]); i++);
  if (i == FILE_NUM) return NULL;
  fclose (FILE_LIST [i]);
  FILE_NUM--;
  for (j=i; j<FILE_NUM; j++)
    FILE_LIST [j] = FILE_LIST[j+1];
  return TRUE;
}

/* closes all files open by the program */

void close_all_files ()
{
  int i;
  for (i=0; i<FILE_NUM; i++)
    fclose (FILE_LIST [i]);
  FILE_NUM = 0;
}


void turn_off_output ()
{
  OUT = fopen (NO_WHERE, "w");
}

void turn_on_output ()
{
  OUT = stdout;
}


