#include "bptt.h"


int get_param_num (char *s_string)
{
  int i;

  for (i=0; param_list[i].name; i++)
    if (str_eq (param_list[i].name, s_string)) return i;

  return BAD;
}

int on_off (char *temp)
{
  if (str_eq (temp, "on")) return 1;
  else
    if (str_eq (temp, "off")) return 0;
    else
      return BAD;
}

void set (string tokens[])
{
  int i, int_num, on_off_num, min, max;
  double float_num;
  string temp;

  i = get_param_num (tokens[1]);

  int_num = atoi (tokens[2]);
  float_num = atof (tokens[2]);
  on_off_num = on_off (tokens[2]);

  if (i == BAD)  err (4, "");

  min = param_list[i].min;
  max = param_list[i].max;

  if ((param_list[i].type == BOOLEAN) && (on_off_num == BAD))
    err (5, "must be set to either ON or OFF");

  if (!(min==max))
    if ((float_num < min) ||
	(float_num > max))
      {
	sprintf (temp, "must be set between %d and %d", min, max);
	err (5, temp);
      }

  switch (param_list[i].type)  {
  case INT : * (int*) (param_list[i].address) = int_num;
             break;
  case REAL : * (double*) (param_list[i].address) = float_num;
              break;
  case BOOLEAN : * (int*) (param_list[i].address) = on_off_num;
                 break;
  }
}

char* get_parameter_string (int i)
{
  string main;
  string temp;

  sprintf (main, "%s = ", param_list[i].name);
  switch (param_list[i].type) {
  case INT: sprintf (temp, "%d", * (int*) (param_list[i].address));
    break;
  case REAL : sprintf (temp, "%6.3f", * (double*) (param_list[i].address));
    break;
  case BOOLEAN : if (* (int*) (param_list[i].address))
    sprintf (temp, "ON"); else sprintf (temp, "OFF");
  }

  strcat (main, temp);
  while (strlen (main) < 25)
    strcat (main, " ");

  return main;
}

void print (string tokens[])
{
  int i;

  i = get_param_num (tokens[1]);

  if (i != BAD)
    fprintf (OUT, "\n   %s\n",  get_parameter_string (i));
  else
    err (4, "");
}
