#include "bptt.h"

int get_epochs (string tokens[])
{
  int epochs;

  if (!(epochs = atoi (tokens [search_tokens (tokens, "-s")])))
    err (2, "");

  return epochs;
}

int get_update (string tokens[])
{
  int update;

  update = search_tokens (tokens, "-u");

  if (! update) update = UPDATE; else
    update = atoi (tokens [update]);

  return update;
}

int get_random (string tokens[])
{
  int random;

  random = search_tokens (tokens, "-R");
  if (! random) random = RANDOM;

  return random;
}

int get_test_flag (string tokens[])
{
  int test_flag;

  test_flag = search_tokens (tokens, "-t");

  return (test_flag && 1);
}

int get_templates (string tokens[], template_type templates[])
{
  int num_templates = 0,
       output_flag;

  if (output_flag = search_tokens (tokens, "-o"))
    num_templates = load_templates (templates, tokens, output_flag);

  return num_templates;
}

int get_rms_flag (string tokens[], FILE **rms_fp)
{
  int rms_flag;

  if (rms_flag = search_tokens (tokens, "-E"))
    {
      if ((tokens [rms_flag][0] != '-') &&
	  (!isdigit (tokens[rms_flag][0])))
	if (check_valid_filename (tokens[rms_flag]))
	  *rms_fp = my_fopen (tokens[rms_flag++], "w");
	else
	  err (1, tokens[rms_flag]);
      else
	*rms_fp = OUT;
      if (isdigit (tokens [rms_flag][0]))
	rms_flag = atoi (tokens[rms_flag]);
      else
	rms_flag = DEFAULT_RMS;
    }
  return rms_flag;
}

int get_lesion_list (string tokens[], int lesion_list[])
{
  int i, lesion_flag;

  if (lesion_flag = search_tokens (tokens, "-lesion"))
    {
      for (i=0; isdigit (tokens [lesion_flag][0]); lesion_flag++, i++)
	if (((lesion_list [i] = atoi (tokens [lesion_flag])) < 0) ||
	    (lesion_list [i] >= NET_UNITS))
	  err (28, "");
      if (i==0) err (29, "");
      lesion_list [i] = BAD;
    }
  return lesion_flag;
}

int get_stimulate_list (string tokens[], int stimulate_list[])
{
  int i, stimulate_flag;

  if (stimulate_flag = search_tokens (tokens, "-stimulate"))
    {
      for (i=0; isdigit (tokens [stimulate_flag][0]); stimulate_flag++, i++)
	if (((stimulate_list [i] = atoi (tokens [stimulate_flag])) < 0) ||
	    (stimulate_list [i] >= NET_UNITS))
	  err (28, "");
      if (i==0) err (29, "");
      stimulate_list [i] = BAD;
    }
  return stimulate_flag;
}


double get_margin (string tokens[])
{
  double margin = 0;
  int i;

  if (i = search_tokens (tokens, "-M"))
    if (!(margin = atof (tokens[i])))
      err (13, "");

  return margin;
}
