#include "bptt.h"

void editor (string tokens[])
{
  int i, j, k, done = 0, num1, num2;
  string com, prompt, temp;
  char *q, *arg;
  FILE *fp;
  string lines[MAX_EDITOR_LINES];

  fprintf (OUT,"\n");

  if (tokens[1][0] == NULL)
    {
      fprintf (OUT,"File name must be specified\n");
      return;
    }

  i = read_editor_file (tokens[1], lines);

  while (!done)
    {
      fprintf (OUT,"\n");
      AT_EDITOR = TRUE;
      while (!(q = do_gets ("editor % ")));
      AT_EDITOR = NULL;
      fprintf (OUT,"\n");

      if ((*q == EOF) || (str_eq (q, ""))) continue;

      strncpy (com, q, MAX_STRING);
      if (arg = strpbrk (com, " "))
	{
	  num1 = atoi (arg+1);
	  if (arg = strpbrk (com, "-"))
	    num2 = atoi (arg+1);
	  else
	    num2 = num1;
	  *strpbrk (com, " ") = NULL;
	}
      else
	num1 = 0;
	  

      if (((str_eq (com, "add")) ||
	   (str_eq (com, "insert"))) &&
	  (i == MAX_EDITOR_LINES))
	{
	  fprintf (OUT,"   Maximum number of lines reached\n");
	  continue;
	}

      if ((i>0) &&
	  ((num1<0) || (num1>=i) ||
	  (num2<0) || (num2>=i)))
	{
	  fprintf (OUT,"   Line numbers out of range\n");
	  continue;
	}

      if (num2 < num1)
	{
	  fprintf (OUT,"   Second number must be larger than first\n");
	  continue;
	}

      if (!good_editor_command (com))
	{
	  fprintf (OUT,"   Unrecognized editor command\n");
	  continue;
	}

      if (str_eq (com, "add"))
	{
	  sprintf (prompt, "   (%s %d) ", tokens[1], i);
	  while (q = do_gets (prompt))
	    {
	      strncpy (lines[i], q, MAX_STRING-1);
	      strcat (lines[i++], "\n");
	      sprintf (prompt, "   (%s %d) ", tokens[1], i);
	      if (i >= MAX_EDITOR_LINES)
		{
		  fprintf (OUT,"\n   Maximum number of lines reached");
		  break;
		}
	    }
	  fprintf (OUT,"\n");
	}

      if (str_eq (com, "insert"))
	{
	  sprintf (prompt, "   (%s %d) ", tokens[1], num1);
	  while (q = do_gets (prompt))
	    {
	      for (j=i; j>num1; j--)
		strncpy (lines[j], lines[j-1], MAX_STRING);
	      strncpy (lines[num1], q, MAX_STRING-1);
	      strcat (lines [num1], "\n");
	      i++;
	      num1++;
	      if (i >= MAX_EDITOR_LINES)
		{
		  fprintf (OUT,"\n   Maximum number of lines reached");
		  break;
		}
	      sprintf (prompt, "   (%s %d) ", tokens[1], num1);
	    }
	  fprintf (OUT,"\n");
	}

      
      if (str_eq (com, "delete"))
	if (i>0)
	  {
	    for (j=num2+1, k = 0;
		 j<i;
		 j++, k++)
	      strncpy (lines [num1+k], lines[j], MAX_STRING);
	    i = i - 1 - num2 + num1;
	  }
	else
	  fprintf (OUT,"No lines to delete\n\n");


      if (str_eq (com, "modify"))
	{
	  strcpy (temp, lines[num1]);
	  temp[strlen (temp)-1] = NULL;
	  add_history (temp);
	  sprintf (prompt, "  (%s %d) ", tokens[1], num1);
	  if (q = do_gets (prompt))
	    {
	      strncpy (lines[num1], q, MAX_STRING-1);
	      strcat (lines [num1], "\n");
	    }
	}

      if (str_eq (com, "new"))
	i = 0;

      if (str_eq (com, "exit"))
	done = TRUE;

      if (str_eq (com, "quit"))
	done = BAD;

      if (str_eq (com, "list"))
	if (i==0)
	  fprintf (OUT,"   Empty File\n");
	else
	  for (j=0; j<i; j++)
	    fprintf (OUT,"   %d :\t%s", j, lines[j]);
    }

  if (done == TRUE)
    {
      fprintf (OUT,"   Saving file \n");
      fp = my_fopen (tokens[1], "w");
      for (j=0; j<i; j++)
	fprintf (fp, "%s", lines[j]);
      my_fclose (fp);
    }
  else
    fprintf (OUT,"   Edit aborted. File not saved\n");

  AT_EDITOR = NULL;
}
  

int good_editor_command (char *com)
{
  int i,
      good = NULL;

  for (i=0; editor_commands[i].name; i++)
    if (str_eq (editor_commands[i].name, com))
      good = TRUE;

  return good;
}

int read_editor_file (char *fname, string lines[])
{
  int i, k;
  FILE *fp;

  for (i=0; i>MAX_EDITOR_LINES; i++)
    lines[i][0] = NULL;

  i = 0;

  if (fp = my_fopen (fname, "r"))
    {
      while (!feof (fp) && (i < MAX_EDITOR_LINES))
	{
	  fgets (lines[i], MAX_STRING-1, fp);
	  if (strlen (lines[i])>1)
	    i++;
	      
	}
      my_fclose (fp);

      if (i==MAX_EDITOR_LINES)
	fprintf (OUT,"   Maximum number of lines has been reached\n\n");
    }

  if (i)
    {
      fprintf (OUT,"   Read %d lines from file\n", i);
      k = strlen (lines[i-1]);
      if (lines[i-1][k-1] != '\n')
	lines[i-1][k] = '\n';
    }
  else
    fprintf (OUT,"   ** Creating file **\n");

  return i;
}

