#include "bptt.h"

#define MUL 0.8
#define total_units (NET_UNITS + NET_INPUTS)


				/* creates a ps weight graph */
				/* kind of hacky, but it works */

void graph_weights (string tokens[])
{
  FILE *fp;

  string
    fname,			/* filename with ".ps" added*/
    title;			/* the title string */

  double
    max,			/* largest weight value */
    xx,				/* just an x counter */
    yy,				/* just a y counter */
    w,				/* just a weight holder */
    width,			/* width of square */
    spacing,			/* spacing between squares */
    x0,				/* left x value of main square */
    y0,				/* lower y value of main square */
    height,			/* height of square */
    cenx,			/* x center position */
    ceny,			/* y center position */
    rf,				/* reference # font size */
    tf;				/* title font size */

  int
    i,				/* counter */
    j,				/* counter */
    a,
    b,
    c,
    d,
    caption,			/* include a caption */
    title_flag,			/* boolean value indicating title */
    key,			/* boolean value indicating a key */
    mod;			/* freq. to print ref. numbers */


				/* what is the filename? */

  strcpy (fname, tokens[1]);
  strcat (fname, ".ps");
  if (!check_valid_filename (fname))
    err (1, fname);
  fprintf (OUT, "\n   Creating \"%s\"", fname);


				/* reference font size */

  if (i=search_tokens (tokens, "-rf"))
    rf = atof (tokens[i]);
  else
    rf = 0.25;
				/* title font size */

  if (i=search_tokens (tokens, "-tf"))
    tf = atof (tokens[i]);
  else
    tf = 0.4;

				/* frequency to print ref marks */

  if (i=search_tokens (tokens, "-m"))
    mod = atoi (tokens[i]);
  else
    mod = 1;

				/* is there a title? */

  title_flag = search_tokens (tokens, "-t") && TRUE;
  

				/* include a key? */

  key = search_tokens (tokens, "-k") && TRUE;

				/* caption? */

  caption = search_tokens (tokens, "-c") && TRUE;

				/* what is the width? */

  if (i=search_tokens (tokens, "-w"))
    width = atof (tokens[i]);
  else
    width = 6;


  fp = my_fopen (fname, "w");


				/* set parameters for size etc. */
  cenx = 4.25;
  ceny = 5.5;

  spacing = width / (total_units);
  height = spacing * (NET_UNITS);
  max = find_max_weights ();
				/* calculate center */
  if (title_flag)
    ceny = ceny - (((tf/2)+0.5)/2);
  if (key)
    ceny = ceny + spacing;
  if (caption)
    ceny = ceny + (rf * 1.5);

				/* calculate lower,left corner of box */

  y0 = ceny - (height/2) + (rf / 2);
  x0 = cenx - (width/2) + (rf / 2);


				/* post script header */

  fprintf (fp, "%%!PS-Adobe\n");	

				/* create the bounding box */

  fprintf (fp, "%%%%BoundingBox: %d %d %d %d\n",
	   a = (int) ((8.5 - width - (rf * 2.3)) / 2) * 72,
	   c = (int) (y0-(spacing*2*key)-((2*rf+0.2)*caption)-rf-0.2) * 72,
	   b = (int) (8.5 - ((8.5 - width - (rf * 2)) / 2)) * 72,
	   d = (int) (y0+height+((0.5 + (tf/2))*title_flag)+0.05) * 72);

				/* add the BPTT header with definitions */

  add_file (fp, PSFILE);

				/* draw the bounding box */
				/* uncomment if testing */

  /* fprintf (fp, "%d 72 div %d 72 div %d 72 div %d 72 div box stroke \n", a, c, b, d); */

  fprintf (fp, "/fs %f def\n", rf);


				/* create the title if neccessary */

  if (i = search_tokens (tokens, "-t"))
    {
      get_string (tokens, i, title);
      fprintf (fp, "\n%%%%%%% Print Title %%%%%%%\n\n");
      fprintf (fp, "%f cs\n",tf);
      fprintf (fp, "4.25 %f (%s) ct\n",
	       y0 + height + 0.5,
	       title);
    }


				/* draw the background, box, and line */

  fprintf (fp, "\n%%%%%% Background %%%%%\n\n");
  fprintf (fp, "0.5 %f %f %f %f fillbox %% background\n\n",
	   x0, y0, x0 +  width, y0 + height);
  fprintf (fp, "%f %f %f %f box stroke %% box \n\n",
	   x0, y0, x0 + width, y0 + height);
  fprintf (fp, "%f %f %f %f L %% input unit separation\n\n",
	   x0 + (NET_INPUTS) * spacing, y0,
	   x0 + (NET_INPUTS) * spacing, y0 + height);



				/* draw the units */

  fprintf (fp, "\n%%%%%% Units %%%%%%%\n\n");
  yy = y0 + (spacing/2);
  for (i=0; i<NET_UNITS; i++)
    {
      xx = x0 + (spacing/2);
      for (j=0; j<total_units; j++)
	{
	  if (j<NET_INPUTS)
	    w = InW [cp][i][j];
	  else
	    w = RW [cp][i][j-NET_INPUTS];

	  if (w<0)
	    fprintf (fp, "0 ");
	  else
	    fprintf (fp, "1 ");

	  fprintf (fp, "%f %f %f fillcbox\n", sqrt(fabs(w) / max) * MUL * spacing, xx, yy);
	  xx = xx + spacing;
	}
      yy = yy + spacing;
    }


				/* draw the reference letters+numbers */

  fprintf (fp, "\n%%%%%% References %%%%%%\n\n");
  fprintf (fp, "%f cs\n", rf);	/* font size */
  yy = y0 + (spacing/2);
  for (i=0; i<NET_UNITS;i++, yy = yy + spacing)
    if (!(i % mod))
      fprintf (fp, "%f %f (r%d) ct\n",
	       x0 - rf, yy, i);
  xx = x0 + spacing/2;
  for (i=0; i<NET_INPUTS;i++, xx = xx + spacing)
    if (!(i % mod))
      fprintf (fp, "%f %f (i%d) ct\n",
	       xx, y0 - rf, i);
  for (i=0; i<NET_UNITS;i++,xx = xx + spacing)
    if (!(i%mod))
      fprintf (fp, "%f %f (r%d) ct\n",
	       xx, y0 - rf, i);


				/* set position */

  yy = y0 - rf - spacing/2 - 0.2;

				/* draw the key */

  if (key)
    {
      fprintf (fp, "\n%%%%%%% Draw the Key %%%%%%%\n\n");
      fprintf (fp, "%f %f %f cbox stroke \n",
	       max * spacing * MUL,
	       cenx,
	       yy);
      fprintf (fp, "%f %f (%6.3lf) lt \n",
	       cenx + spacing / 2, yy,
	       max);
      yy = yy - spacing;
      fprintf (fp, "0 %f %f %f fillcbox \n",
	       max * spacing * MUL,
	       cenx,
	       yy);
      fprintf (fp, "%f %f (-%6.3lf) lt \n",
	       cenx + spacing / 2, yy,
	       max);
      yy = yy - (spacing/2) - 0.2;
    }

				/* draw the caption */

  if (caption)
    {
      fprintf (fp, "\n%%%%%%%% Caption %%%%%%%\n\n");
      fprintf (fp, "%f cs\n", rf);
      fprintf (fp, "%f %f (Black squares are negative and white squares are positive) ct\n",
	       cenx, yy);
      yy = yy - rf;
      fprintf (fp, "%f %f (Maximum Weight =%6.3lf) ct\n", cenx, yy, max);
    }

  
  fprintf (fp, "\nend\n\n");
  fprintf (fp, "\n\nshowpage\n");
  my_fclose (fp);
  fprintf (OUT, "\n   Maximum Weight Value:%6.3lf\n", max);

}


double find_max_weights ()
{
  int x,y;
  double max;

  max = 0;
  for (x=0; x<NET_UNITS; x++)
    {
      for (y=0; y<NET_UNITS; y++)
	if (fabs(RW[cp][x][y]) > max)
	  max = fabs(RW[cp][x][y]);
      for (y=0; y<NET_INPUTS; y++)
	if (fabs(InW[cp][x][y]) > max)
	  max = fabs(InW[cp][x][y]);
    }
  return max;
}

				/* adds the file in fname to the */
				/* current file pointed to by fp */

void add_file (FILE *fp, char *fname)
{
  FILE *out;
  char t;

  out = my_fopen (fname, "r");

  if (!out)
    err (39, fname);

  while ((t = fgetc (out)) != EOF)
    fputc (t, fp);
  my_fclose (out);
}

				/* read the next string from the command */
				/* line, terminated by "-" or NULL */

void get_string (string tokens[], int i, char *ret_str)
{
  *ret_str = NULL;
  if (!(*tokens[i]) || (*tokens[i] == '-'))
    return;

  strcpy (ret_str, tokens[i++]);
  while (*tokens[i] && (*tokens[i] != '-'))
    {
      strcat (ret_str, " ");
      strcat (ret_str, tokens[i++]);
    }
}
